#!/usr/bin/python
#-*- coding: utf-8 -*-
#
# BD_CREATION_BASE.py

from os import chdir
from os import listdir

# Se déplacer dans le dossier en cours si besoin
path = r'P:\PRO\USB\NSI\NSI TERM\PREPA BASE DE DONNEES\TP_ENTREPRISE_DE_MON_COUSIN'
chdir(path)


import sqlite3

from sqlite3 import Error
 
def creer_connexion(db_file):
    """ 
    cree une connexion a la base de donnees SQLite
    specifiee par db_file
    :param db_file: fichier BD
    :return: objet connexion ou None
    """
    try:
        conn = sqlite3.connect(db_file)
        #On active les foreign keys
        conn.execute("PRAGMA foreign_keys = 1")
        return conn
    except Error as e:
        print(e)
         
    return None
 

def majBD(conn, file):

    # Lecture du fichier et placement des requetes dans un tableau
    createFile = open(file, 'r', encoding="UTF-8")
    createSql = createFile.read()
    createFile.close()
    sqlQueries = createSql.split(";")

    # Execution de toutes les requetes du tableau
    cursor = conn.cursor()
    for query in sqlQueries:
        cursor.execute(query)

        
def main():
    database = "ENTREPRISE_DE_MON_COUSIN.db"

    # creer une connexion a la BD
    conn = creer_connexion(database)
    
    # remplir la BD 
    print("1. On cree la base de données.")
    majBD(conn, "CREATION_BASE.sql")
    conn.commit()
        
    # Fermeture des objets de connexion et d'interface
    conn.close()
    
if __name__ == "__main__":
    main()
