#!/usr/bin/python
#-*- coding: utf-8 -*-
#
# Script_TP_BD_2.py

from os import chdir
from os import listdir

# Se déplacer dans le dossier en cours si besoin
path = r'P:\PRO\USB\NSI\NSI TERM\PREPA BASE DE DONNEES\TP_ENTREPRISE_DE_MON_COUSIN'
chdir(path)

import csv
import time
import sqlite3
from sqlite3 import Error
 
def creerConnexion(db_file):
    """ 
    cree une connexion a la base de donnees SQLite
    specifiee par db_file
    Entree:
        param db_file: fichier BD
    Sortie:
        objet connexion ou None
    """
    try:
        conn = sqlite3.connect(db_file)
        #On active les foreign keys
        conn.execute("PRAGMA foreign_keys = 1")
        return conn
    except Error as e:
        print(e)
 
    return None
 
 
def executionRequeteInsertion(conn, requete):
    """
    Exécute une requête sql sur la table connectée via conn
    Entrée :
        param conn: objet connexion
        requete: requete au format SQL
    Sortie :
        Aucune
    """
    try:
        cur = conn.cursor()
        cur.execute(requete)
        conn.commit()
    except Error as e:
        print(e)
        print()        
    

def lectureFichierData(nom_fichier):
    '''
        Lecture d'un fichier csv, le résultat est dans une 
        liste de listes
        Entrée :
            Le nom complet du fichier
        Sortie :
            Une table contenant toutes les lignes
            du fichier sous la forme d'une liste de 
            listes
    '''
    with open(nom_fichier, encoding="utf8") as myFile:
        reader = csv.reader(myFile, delimiter=';')
        for row in reader:  
            table.append(row)	            

    return table

def creationRequeteComposants(cle,row):
    '''
        Création des requêtes d'insertion dans la table Composants
    '''
    requete = 'INSERT INTO Composants VALUES ('
    requete = ''' A compléter '''
    
    return requete

        
## PROGRAMME PRINCIPAL

# On créer la liste vide
table=[]

# Nom de la base de données
database = "ENTREPRISE_DE_MON_COUSIN.db"

# creer une connexion a la BD
conn = creerConnexion(database)

# Lecture du fichier de données csv
table = lectureFichierData('CATALOGUE_PRIX_COMPOSANTS.csv')    

# Pour toutes les lignes du fichier csv sauf la première
# création de la requête sql et exécution de cette requête
#
# Format de la requête exemple :
# INSERT INTO Composants VALUES (1,'Capacitors','10uF','1144640','Farnell',0.345);

for x in range(1,len(table)):
    requete = creationRequeteComposants(x,table[x])
    print('EXECUTION REQUETE => ',requete)
    executionRequeteInsertion(conn, requete)
    time.sleep(1)    

# Fermeture des objets de connexion et d'interface
conn.close()
    

